#// lastpost.awk
#// what was the last post?
#// 20.03.2015
#// 
#// Copyright (C) 2015  Balthasar Szczepański
#// 
#// This program is free software: you can redistribute it and/or modify
#// it under the terms of the GNU Affero General Public License as
#// published by the Free Software Foundation, either version 3 of the
#// License, or (at your option) any later version.
#// 
#// This program is distributed in the hope that it will be useful,
#// but WITHOUT ANY WARRANTY; without even the implied warranty of
#// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#// GNU Affero General Public License for more details.
#// 
#// You should have received a copy of the GNU Affero General Public License
#// along with this program.  If not, see <http://www.gnu.org/licenses/>.

BEGIN{
	FS=""
}
{
	if ((i=match($0, /id=\"p[0-9]+\"/))!=0) #"
	{
		temp=substr($0, i+5)
		postid=substr(temp, 1, index(temp,"\"")-1)
	}
	
	if ($0 ~ /class=\"postprofile\"/) #"
		postprofile = "1"
	
	else if (postprofile=="")
		next
	
	if($0 ~ /memberlist\.php.*mode=viewprofile[^<>]*>[^<>]+<\/a/)
	{
		temp=substr($0, index($0, ">")+1)
		username=substr(temp, 1, index(temp,"<")-1)
		exit
	}
}
END{
	print postid
	print username
}