#// mome.awk
#// automome ONGification
#// 16.01.2015
#// 
#// Copyright (C) 2015  Balthasar Szczepański
#// 
#// This program is free software: you can redistribute it and/or modify
#// it under the terms of the GNU Affero General Public License as
#// published by the Free Software Foundation, either version 3 of the
#// License, or (at your option) any later version.
#// 
#// This program is distributed in the hope that it will be useful,
#// but WITHOUT ANY WARRANTY; without even the implied warranty of
#// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#// GNU Affero General Public License for more details.
#// 
#// You should have received a copy of the GNU Affero General Public License
#// along with this program.  If not, see <http://www.gnu.org/licenses/>.

BEGIN{
	printf("")>outfile
	for(i=0;i<256;++i)
	{
		ch=sprintf("%c",i)
		hex=sprintf("%02X",i);
		ch2hex[ch]=hex
	}
}
{
	if(sub(/[AEIOUY]-N-G/,"[b]O-N-G[/b]",$0)>0)
	{
		print prepare($0) > outfile
		exit
	}
	if(sub(/O+N+G+/,"[b]&[/b]",$0)>0)
	{
		print prepare($0) > outfile
		exit
	}
	if(sub(/DON'T/,"D[b]ON'G[/b]T",$0)>0)
	{
		print prepare($0) > outfile
		exit
	}
	if(sub(/[AEIOUY]NG/,"[b]ONG[/b]",$0)>0)
	{
		if($0!~/TH\[b\]ONG/)
		{
		print prepare($0) > outfile
			exit
		}
	}
	if(sub(/ON /,"[b]ONG[/b] ",$0)>0)
	{
		print prepare($0) > outfile
		exit
	}
	if(sub(/O\.?$/,"[b]ONG[/b] ",$0)>0)
	{
		print prepare($0) > outfile
		exit
	}
};
function urlencode(name,   len,iii,escaped,ch)
{
	len=length(name)
	escaped=""
	for(iii=1;iii<=len;++iii)
	{
		ch=substr(name,iii,1);
		if (ch ~ /[a-z]|[A-Z]|[0-9]/)
			escaped = escaped ch
		else
			escaped = escaped "%" ch2hex[ch]
	}
	return escaped
};
function prepare(rh)
{
	gsub(/\*\*/,"¤",rh)
	gsub(/\*[^\*]+\*/,"±&±",rh)
	gsub(/±\*/,"[i]",rh)
	gsub(/\*±/,"[/i]",rh)
	gsub(/¤/,"*",rh)
	
	gsub(/__/,"¤",rh)
	gsub(/_[^_]+_/,"±&±",rh)
	gsub(/±_/,"[u]",rh)
	gsub(/_±/,"[/u]",rh)
	gsub(/¤/,"_",rh)
	
	gsub(/\$\$/,"¤",rh)
	gsub(/\$[^\$]+\$/,"±&±",rh)
	gsub(/±\$/,"[size=80]",rh)
	gsub(/\$±/,"[/size]",rh)
	gsub(/¤/,"$",rh)
	
	return urlencode(rh  " -- [url=http://1190.bicyclesonthemoon.info/ongtext?b=on][b]ong[/b]o[/url][url=http://mrob.com/time/automome/]mome[/url]")
}
