// remove.c (1190.bicyclesonthemoon.info/ct-if-r)
// remove a post
// 23.11.2014
// 
// Copyright (C) 2014  Balthasar Szczepański
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include <cgi.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

#define POST_PATH "/eizm/mem/ong1/mpost/"
#define WAIT_PATH "/eizm/mem/ong1/mpost/wait/"
#define RMOV_PATH "/eizm/mem/ong1/mpost/rm/"
#define MV_PATH "/bin/mv"

int main(int argc, char **argv)
{
	s_cgi *cgi;
	pid_t sub;
	int r;
	unsigned char fff;
	
	char zero='\0';
	char *rmov = &zero;
	char *arg;
	char inpath[256];
	char outpath[256];
	
	cgi=cgiInit();
	
	fff=(cgiGetValue(cgi,"fff")!=NULL);
	if(cgiGetValue(cgi,"no")!=NULL)
	{
		cgiRedirect(fff?"/ct-if?fff=fff":"/ct-if");
		return(0);
	}
	
	if(cgiGetValue(cgi,"yes")==NULL)
	{
		arg=cgiGetValue(cgi,"r");
		if(arg!=NULL)
			rmov=arg;
		printf("Content-type: text/html\n\n");
		printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"\">\n");
		printf("<html lang=\"en\"><head>\n");
		printf("<title>Chronotransponder test interface &bull; Bicycles on the Moon</title>\n");
		printf("<meta http-equiv=\"Content-type\" content=\"text/html; charset=UTF-8\">\n");
		printf("<link rel=\"icon\" type=\"image/png\" href=\"/img/favicon.png\">\n");
		printf("<link rel=\"stylesheet\" href=\"/css/botm.css\">\n");
		printf("</head><body>\n");
		printf("<img src=\"/img/botmlogo2.png\" alt=\"1190.bicyclesonthemoon.info\" border=\"0\">\n");
		printf("<h1>Chronotransponder test interface</h1>\n");
		printf("<form action=\"/ct-if-r\" method=\"post\">\n");
		printf("<b>Remove message %s?</b><br>\n",rmov);
		if(fff)
			printf("<input type=\"hidden\" name=\"fff\" value=\"fff\">\n");
		printf("<input type=\"submit\" class=\"pk\" name=\"yes\" value=\"Yes\">\n");
		printf("<input type=\"submit\" class=\"pk\" name=\"no\"  value=\"No\">\n");
		printf("<input type=\"hidden\" name=\"r\" value=\"%s\">\n",rmov);
		printf("</form><br><a href=\"/\">1190.bicyclesonthemoon.info</a></body></html>\n");
		return 0;
	}
	
	arg=cgiGetValue(cgi,"r");
	if(arg==NULL)
	{
		cgiRedirect(fff?"/ct-if?fff=fff":"/ct-if");
		return(0);
	}
	rmov=arg;
	
	if(rmov[0]=='c'&&rmov[1]=='t')
		sprintf(inpath,"%s%s",POST_PATH,rmov+2);
	else if(rmov[0]=='w'&&rmov[1]=='t')
		sprintf(inpath,"%s%s",WAIT_PATH,rmov+2);
	else
	{
		cgiRedirect(fff?"/ct-if?fff=fff":"/ct-if");
		return(0);
	}
	sprintf(outpath,"%s%s",RMOV_PATH,rmov+2);
	
	sub=fork();
	if(sub==0)
	{
		r=execl(MV_PATH,MV_PATH,inpath,outpath,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	cgiRedirect(fff?"/ct-if?fff=fff":"/ct-if");
	return 0;
}